-- // CA_UIM_IBMVM_REST_DB da dml

--	CCC 2.9  - CA_UIM_IBMVM_REST_DB data adapter

--	Data source Type

INSERT INTO ${owner}.SOURCE_TYPE_CONFIG(TYPE_ID,TYPE,DESCRIPTION,XML_MAPPING_FILE,DB_QUERY,  SERVERLIST_MAPPING_FILE,  CREATE_DATE, AUTHOR, COPYRIGHT, ORIGIN, ENABLED,METRIC_FAMILY_ID)
 SELECT source_type_config_seq.nextval, 'CA_UIM_IBMVM_REST_DB', 'CA UIM IBMVM REST', 'ca_uim_ibmvm_rest_db.xml','2',NULL, sysdate,'CA Technologies', 'Copyright 2014 CA. All rights reserved.',0, 1, 1 FROM dual 
 WHERE NOT EXISTS (SELECT 1 FROM source_type_config WHERE type ='CA_UIM_IBMVM_REST_DB')
/ 

 
--	Data source params
INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'HostName', 'Host name/IP address', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'HostName' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'Port', 'Port number', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'Port' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'DbName', 'Database name', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'DbName' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'DbUser', 'Database user name', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'DbUser' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'DbPass', 'Database password', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'DbPass' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'DbPlatform', 'Database platform', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'DbPlatform' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'RSSRV', 'Select resource servers', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'RSSRV' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'TIME_ZONE', 'Server time zone', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'TIME_ZONE' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 INSERT INTO ${owner}.source_params_config(param_id, name, description, type_id) 
 SELECT source_params_config_seq.nextval, 'METRICGROUP_SYSTEM', 'System Metric', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.source_params_config WHERE name = 'METRICGROUP_SYSTEM' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB'))
 /
 
 INSERT INTO ${owner}.SOURCE_PARAMS_CONFIG (PARAM_ID, NAME, DESCRIPTION,TYPE_ID)
 SELECT source_params_config_seq.nextval, 'JDBC_URL', 'JDBC URL for database connection', (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') FROM dual 
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.SOURCE_PARAMS_CONFIG WHERE NAME = 'JDBC_URL' AND type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB')) 
 /
 
  -- Declare constraints for CA_UIM_IBMVM_REST_DB
  
 INSERT INTO ${owner}.SOURCE_PARAMS_CNSTRT_CONFIG ( PARAM_ID, VALUE,INCLUDE_FLAG )
 SELECT (SELECT param_id FROM ${owner}.source_params_config WHERE type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') AND name = 'DbPlatform'), 'Oracle', '1' FROM dual
 WHERE NOT EXISTS (SELECT 1 FROM ${owner}.SOURCE_PARAMS_CNSTRT_CONFIG WHERE param_id= (SELECT param_id FROM ${owner}.source_params_config WHERE type_id = (SELECT type_id FROM ${owner}.SOURCE_TYPE_CONFIG WHERE type ='CA_UIM_IBMVM_REST_DB') AND name = 'DbPlatform') and value ='Oracle')
 /

 --	List of metrics loaded by the IBMVM data adapter

 --	Server/host metrics (2)
 
 insert into ${owner}.METRIC_DIM (METRIC_DIM_ID, METRIC_SOURCE, METRIC_TYPE, METRIC_GROUP, CODE, SRC_NAME, STD_NAME, DISPLAY_NAME, DESCRIPTION, UNIT, DERIVED_FLAG)
 select metric_dim_id_seq.nextval, 'CA_UIM_IBMVM_REST_DB', 'System', 'Server', 'GBL_POOL_CPU_UTIL', 'host_cpu_global_shared_processor_pool_utilization', 'GBL_POOL_CPU_UTIL', 'GBL_POOL_CPU_UTIL', 'Pool CPU Utilization', 'percent', '0' from dual
 where not exists ( select 1 from ${owner}.metric_dim where METRIC_SOURCE = 'CA_UIM_IBMVM_REST_DB' and STD_NAME =  'GBL_POOL_CPU_UTIL')
 /
 insert into ${owner}.METRIC_DIM (METRIC_DIM_ID, METRIC_SOURCE, METRIC_TYPE, METRIC_GROUP, CODE, SRC_NAME, STD_NAME, DISPLAY_NAME, DESCRIPTION, UNIT, DERIVED_FLAG)
 select metric_dim_id_seq.nextval, 'CA_UIM_IBMVM_REST_DB', 'System', 'Server', 'GBL_POOL_CPU_SIZE', 'host_global_shared_processor_pool_size', 'GBL_POOL_CPU_SIZE', 'GBL_POOL_CPU_SIZE', 'Pool CPU Size', 'Number', '0' from dual
 where not exists ( select 1 from ${owner}.metric_dim where METRIC_SOURCE = 'CA_UIM_IBMVM_REST_DB' and STD_NAME =  'GBL_POOL_CPU_SIZE')
 /
 
--	LPAR metrics (2)

insert into ${owner}.METRIC_DIM (METRIC_DIM_ID, METRIC_SOURCE, METRIC_TYPE, METRIC_GROUP, CODE, SRC_NAME, STD_NAME, DISPLAY_NAME, DESCRIPTION, UNIT, DERIVED_FLAG)
 select metric_dim_id_seq.nextval, 'CA_UIM_IBMVM_REST_DB', 'LS_System', 'LS_Server', 'GBL_LS_MEM_MB_USAGE', 'vm_memory_used', 'GBL_LS_MEM_MB_USAGE', 'GBL_LS_MEM_MB_USAGE', 'Megabytes of physical memory consumed by the logical system', 'megabytes', '0' from dual
 where not exists ( select 1 from ${owner}.metric_dim where METRIC_SOURCE = 'CA_UIM_IBMVM_REST_DB' and STD_NAME =  'GBL_LS_MEM_MB_USAGE')
 /
insert into ${owner}.METRIC_DIM (METRIC_DIM_ID, METRIC_SOURCE, METRIC_TYPE, METRIC_GROUP, CODE, SRC_NAME, STD_NAME, DISPLAY_NAME, DESCRIPTION, UNIT, DERIVED_FLAG)
 select metric_dim_id_seq.nextval, 'CA_UIM_IBMVM_REST_DB', 'LS_System', 'LS_Server', 'GBL_LS_VIRT_MEM_UTIL', 'vm_memory_used / vm_memory_assigned', 'GBL_LS_VIRT_MEM_UTIL', 'GBL_LS_VIRT_MEM_UTIL', 'LPAR memory utilization with respect to entitlement (percent)', 'percent', '0' from dual
 where not exists ( select 1 from ${owner}.metric_dim where METRIC_SOURCE = 'CA_UIM_IBMVM_REST_DB' and STD_NAME =  'GBL_LS_VIRT_MEM_UTIL')
 /
 
commit
/
 
 -- //@UNDO
-- SQL to undo the change goes here

--	Delete statements for CA_UIM_IBMVM_REST_DB

delete from ${owner}.metric_dim where metric_source ='CA_UIM_IBMVM_REST_DB'
/
delete from ${owner}.SOURCE_PARAMS_CNSTRT_CONFIG where param_id in (select param_id from ${owner}.source_params_config where type_id =(select type_id from ${owner}.SOURCE_TYPE_CONFIG where type='CA_UIM_IBMVM_REST_DB'))
/
delete from ${owner}.source_params_config where type_id =(select type_id from ${owner}.SOURCE_TYPE_CONFIG where type='CA_UIM_IBMVM_REST_DB')
/
delete from ${owner}.SOURCE_TYPE_CONFIG where type='CA_UIM_IBMVM_REST_DB'
/

 
